/*******************************************************************************
 * FoxWeaponAttachment_HRVJammerPackBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeaponAttachment_HRVJammerPackBase extends FoxWeaponAttachment_GrenadeBase
    config(Weapon)
    notplaceable
    hidecategories(Navigation);

var() export editinline ParticleSystemComponent JammerPSC;
var transient bool bJammerAttached;

simulated function AttachWeaponTo(SkeletalMeshComponent MeshCpnt, optional name SocketName)
{
    local FoxPawn FP;

    super(FoxWeaponAttachment).AttachWeaponTo(MeshCpnt, SocketName);
    // End:0x162
    if((WorldInfo.NetMode != NM_DedicatedServer) && !bJammerAttached)
    {
        FP = FoxPawn(Instigator);
        // End:0x162
        if((JammerPSC != none) && !IsFirstPerson())
        {
            // End:0x162
            if((FP != none) && FP.AttachSlots[WeaponSlot].SocketName == SocketName)
            {
                JammerPSC.DetachFromAny();
                JammerPSC.SetTranslation(vect(0.0, 0.0, -48.0));
                Instigator.AttachComponent(JammerPSC);
            }
        }
    }
    //return;    
}

simulated function StartFiringSound(const byte FireModeNum)
{
    local class<FoxWeapon_HRVJammerPackBase> JammerWeaponClass;

    PlayWeaponSound(FireSound, 1.0);
    bPlayingFiringSound = true;
    JammerWeaponClass = class<FoxWeapon_HRVJammerPackBase>(WeaponClass);
    SetTimer(JammerWeaponClass.default.WarmupTime, false, 'ActivateJammerPSC');
    //return;    
}

simulated function StopFiringSound(const byte FireModeNum)
{
    PlayWeaponSound(TailSound, 1.0);
    bPlayingFiringSound = false;
    DeactivateJammerPSC();
    //return;    
}

simulated function ActivateJammerPSC()
{
    // End:0xB4
    if((WorldInfo.NetMode != NM_DedicatedServer) && FoxGRI(WorldInfo.GRI).IsActorFriendlyToLocalPlayer(Instigator))
    {
        JammerPSC.SetHidden(false);
        JammerPSC.ActivateSystem();
    }
    //return;    
}

simulated function DeactivateJammerPSC()
{
    ClearTimer('ActivateJammerPSC');
    // End:0x7C
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        JammerPSC.SetHidden(true);
        JammerPSC.DeactivateSystem();
    }
    //return;    
}

simulated function DetachWeapon()
{
    local editinline SkeletalMeshComponent PawnMesh;
    local FoxPawn OwnerPawn;

    OwnerPawn = ((Instigator != none) ? FoxPawn(Instigator) : FoxPawn(Owner));
    // End:0x76
    if(OwnerPawn != none)
    {
        PawnMesh = OwnerPawn.Mesh;
    }
    // End:0x12A
    if(Mesh != none)
    {
        // End:0xEA
        if((PawnMesh != none) && PawnMesh.IsComponentAttached(Mesh))
        {
            PawnMesh.DetachComponent(Mesh);
        }
        Mesh.SetShadowParent(none);
        Mesh.SetLightEnvironment(none);
    }
    //return;    
}

simulated function StopFireEffects(byte FireMode)
{
    StopWeaponSet(AN_NormalFire);
    super(FoxWeaponAttachment).StopFireEffects(FireMode);
    //return;    
}

simulated event Destroyed()
{
    JammerPSC.DetachFromAny();
    StopFiringSound(0);
    super(FoxWeaponAttachment).Destroyed();
    //return;    
}

defaultproperties
{
    begin object name=JammerComponent1 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
        HiddenGame=true
        AbsoluteRotation=true
    object end
    // Reference: ParticleSystemComponent'Default__FoxWeaponAttachment_HRVJammerPackBase.JammerComponent1'
    JammerPSC=JammerComponent1
    begin object name=AttachmentMesh class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxWeaponAttachment_HRVJammerPackBase.AttachmentMesh'
    Mesh=AttachmentMesh
    MuzzleFlashLight=PointLightComponent'Default__FoxWeaponAttachment_HRVJammerPackBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.32523580
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeaponAttachment_HRVJammerPackBase.LensComp'
    MuzzleLensFlare=LensComp
    begin object name=AttachmentMesh class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxWeaponAttachment_HRVJammerPackBase.AttachmentMesh'
    Components(0)=AttachmentMesh
    begin object name=JammerComponent1 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
        HiddenGame=true
        AbsoluteRotation=true
    object end
    // Reference: ParticleSystemComponent'Default__FoxWeaponAttachment_HRVJammerPackBase.JammerComponent1'
    Components(1)=JammerComponent1
}